﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ExtMVCOne.Models;
using Newtonsoft.Json.Linq;
using ExtMVCOne.Helper;
using System.Web.Security;

namespace ExtMVCOne.Controllers
{
    public class AccountController : Controller
    {
        //
        // GET: /Account/

        public JObject Login(LoginModel model)
        {
            bool success = false;
            JObject errors = new JObject();
            if (ModelState.IsValid)
            {
                string vcode = "";
                if (Session["vcode"] != null)
                {
                    vcode = Session["vcode"].ToString();
                }
                if (vcode.Count() > 0 && vcode.ToLower() == model.Vcode.ToLower())
                {
                    MembershipUser user = Membership.GetUser(model.UserName);
                    if (user != null)
                    {
                        if (user.IsApproved)
                        {
                            TimeSpan ts = user.LastLockoutDate.AddMinutes(60) - DateTime.Now;
                            if (user.IsLockedOut && ts.Minutes > 0)
                            {
                                errors.Add("UserName", "用户名已被锁定，" + ts.Minutes + "分钟后才能再次尝试登录。");
                            }
                            else
                            {
                                if (user.IsLockedOut) user.UnlockUser();
                                if (Membership.ValidateUser(model.UserName, model.Password))
                                {
                                    if (Roles.IsUserInRole(model.UserName, "系统管理员 ") | Roles.IsUserInRole(model.UserName, "普通用户"))
                                    {
                                        FormsAuthentication.SetAuthCookie(model.UserName, false);
                                        success = true;
                                    }
                                    else
                                    {
                                        errors.Add("UserName", "您没有权限登录系统。");
                                    }
                                }
                                else
                                {
                                    errors.Add("UserName", "错误的用户名或密码。");
                                    errors.Add("Password", "错误的用户名或密码。");
                                }
                            }
                        }
                    }
                    else
                    {
                        errors.Add("UserName", "错误的用户名或密码。");
                        errors.Add("Password", "错误的用户名或密码。");
                    }
                }
                else
                {
                    errors.Add("Vcode", "验证码错误");
                }
            }
            else
            {
                MyFunction.ModelStateToJObject(ModelState, errors);
            }
            return MyFunction.WriteJObjectResult(success, errors);
        }
        public ActionResult Logout()
        {
            FormsAuthentication.SignOut();
            return RedirectToAction("Index", "Home");
        }
    }
}
